data:extend({

--- express-loader-z
{
    type = "loader",
    name = "express-loader-z",
    icon = "__base__/graphics/icons/express-loader.png",
    icon_size = 32,
    --- flags = {"placeable-neutral", "player-creation", "fast-replaceable-no-build-while-moving"},
    minable = {mining_time = 0.1, result = "express-loader-z"},
    max_health = 170,
    filter_count = 5,
    corpse = "small-remnants",
    resistances =
    {
      {
        type = "fire",
        percent = 60
      }
    },
    collision_box = {{-0.4, -0.9}, {0.4, 0.9}},
    selection_box = {{-0.5, -1}, {0.5, 1}},
    animation_speed_coefficient = 32,
    belt_animation_set = express_belt_animation_set,
    fast_replaceable_group = "loader",
    speed = 0.09375,
    structure =
    {
      direction_in =
      {
        sheet =
        {
          filename = "__base__/graphics/entity/loader/loader-structure.png",
          priority = "extra-high",
          width = 64,
          height = 64
        }
      },
      direction_out =
      {
        sheet =
        {
          filename = "__base__/graphics/entity/loader/loader-structure.png",
          priority = "extra-high",
          width = 64,
          height = 64,
          y = 64
        }
      }
    }
  },

   {
    type = "item",
    name = "express-loader-z",
    icon = "__base__/graphics/icons/express-loader.png",
    icon_size = 32,
    flags = {"hidden"},
    subgroup = "belt",
    order = "d[loader]-c[express-loader]",
    place_result = "express-loader-z",
    stack_size = 50
  },




-- TECH


{
    type = "technology",
    name = "circuit-factory",
    icon_size = 128,
    icon = "__base__/graphics/technology/automation.png",
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "circuit-factory"
      },
	  {
        type = "unlock-recipe",
        recipe = "electronic-circuit-factory"
      },
	  {
        type = "unlock-recipe",
        recipe = "advanced-circuit-factory"
      },
	  {
        type = "unlock-recipe",
        recipe = "processing-unit-factory"
      },
    },
    prerequisites = {"automation-3"},
    unit =
    {
      count = 150,
      ingredients =
      {
        {"automation-science-pack", 1},
        {"logistic-science-pack", 1},
        {"chemical-science-pack", 1},
        {"production-science-pack", 1}
      },
      time = 60
    },
    order = "a-b-c"
  },


-- CIRCUIT FACTORY
{
    type = "recipe",
    name = "circuit-factory",
    enabled = false,
    ingredients =
    {
      {"speed-module-3", 5},
      {"assembling-machine-3", 5},
	  {"stack-inserter", 20}
    },
    result = "circuit-factory"
  },
  
  
  {
    type = "item",
    name = "circuit-factory",
    icon = "__CircuitFactory__/graphics/circuitfactory.png",
    icon_size = 32,
  --  flags = {"goes-to-quickbar"},
    subgroup = "production-machine",
    order = "c[big-assembling-machine]",
    place_result = "circuit-factory",
    stack_size = 50
  },
  
  {
    type = "assembling-machine",
    name = "circuit-factory",
    icon = "__CircuitFactory__/graphics/circuitfactory.png",
    icon_size = 32,
    flags = {"placeable-neutral","placeable-player", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "circuit-factory"},
    max_health = 400,
    corpse = "big-remnants",
    dying_explosion = "big-explosion",
    alert_icon_shift = util.by_pixel(-3, -12),
    resistances =
    {
      {
        type = "fire",
        percent = 70
      }
    },
    fluid_boxes =
    {
      {
        production_type = "input",
        pipe_picture = assembler3pipepictures(),
        pipe_covers = pipecoverspictures(),
        base_area = 10,
        base_level = -1,
        pipe_connections = {{ type="input", position = {1, -9} }},
        secondary_draw_orders = { north = -1 }
      },
      {
        production_type = "output",
        pipe_picture = assembler3pipepictures(),
        pipe_covers = pipecoverspictures(),
        base_area = 10,
        base_level = 1,
        pipe_connections = {{ type="output", position = {1, 9} }},
        secondary_draw_orders = { north = -1 }
      },
      off_when_no_fluid_recipe = true
    },
    open_sound = { filename = "__base__/sound/machine-open.ogg", volume = 0.85 },
    close_sound = { filename = "__base__/sound/machine-close.ogg", volume = 0.75 },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    working_sound =
    {
      sound = {
        {
          filename = "__base__/sound/assembling-machine-t3-1.ogg",
          volume = 0.8
        },
        {
          filename = "__base__/sound/assembling-machine-t3-2.ogg",
          volume = 0.8
        },
      },
      idle_sound = { filename = "__base__/sound/idle1.ogg", volume = 0.6 },
      apparent_volume = 1.5,
    },
    collision_box = {{-8.1, -8.1}, {8.1, 8.1}},
    selection_box = {{-8.8, -9}, {8.8, 9}},
    drawing_box = {{-8.8, -8.8}, {8.8, 8.8}},
    animation =
    {
      layers =
      {
        {
          filename = "__base__/graphics/entity/assembling-machine-3/assembling-machine-3.png",
          priority = "high",
          width = 108,
          height = 119,
          frame_count = 32,
          line_length = 8,
          shift = util.by_pixel(0, -0.5),
		  scale = 6,
          hr_version = {
            filename = "__base__/graphics/entity/assembling-machine-3/hr-assembling-machine-3.png",
            priority = "high",
            width = 214,
            height = 237,
            frame_count = 32,
            line_length = 8,
            shift = util.by_pixel(0, -0.75),
            scale = 3
          }
        },
        {
          filename = "__base__/graphics/entity/assembling-machine-3/assembling-machine-3-shadow.png",
          priority = "high",
          width = 130,
          height = 82,
          frame_count = 32,
          line_length = 8,
		  scale = 6,
          draw_as_shadow = true,
          shift = util.by_pixel(28, 4),
          hr_version = {
            filename = "__base__/graphics/entity/assembling-machine-3/hr-assembling-machine-3-shadow.png",
            priority = "high",
            width = 260,
            height = 162,
            frame_count = 32,
            line_length = 8,
            draw_as_shadow = true,
            shift = util.by_pixel(28, 4),
            scale = 3
          }
        },
      },
    },

    crafting_categories = {"circuits"},
    crafting_speed = 3,
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input",
      emissions = 0.03 / 3.5
    },
    energy_usage = "1000kW",
    ingredient_count = 10,
    module_specification =
    {
      module_slots = 5
    },
    allowed_effects = {"consumption", "speed", "productivity", "pollution"}
  },
  
  
   
  -- CIRCUIT RECIPES
  
  {
    type = "recipe",
    name = "electronic-circuit-factory",
	category = "circuits",
    normal =
    {
      ingredients =
      {
        {"iron-plate", 100},
        {"copper-plate", 150}
      },
	  enabled = false,
      result = "electronic-circuit",
	  result_count = 100
    },
    expensive =
    {
      ingredients =
      {
        {"iron-plate", 200},
        {"copper-plate", 500}
      },
	  enabled = false,
      result = "electronic-circuit",
	  result_count = 100
    }
  },
  
  
  
  {
    type = "recipe",
    name = "advanced-circuit-factory",
	category = "circuits",
    normal =
    {
      enabled = false,
      energy_required = 6,
      ingredients =
      {
        {"electronic-circuit", 100},
        {"plastic-bar", 100},
        {"copper-plate", 100}  
      },
      result = "advanced-circuit",
	  result_count = 50
    },
    expensive =
    {
      enabled = false,
      energy_required = 6,
      ingredients =
      {
        {"electronic-circuit", 100},
        {"plastic-bar", 200},
        {"copper-plate", 200}
      },
      result = "advanced-circuit",
	  result_count = 50
    }
  },
  
  
  
  
  
  {
    type = "recipe",
    name = "processing-unit-factory",
    category = "circuits",
    normal =
    {
      enabled = false,
      energy_required = 10,
      ingredients =
      {
        {"electronic-circuit", 1000},
        {"advanced-circuit", 100},
        {type = "fluid", name = "sulfuric-acid", amount = 250}
      },
      result = "processing-unit",
	  result_count = 50
    },
    expensive =
    {
      enabled = false,
      energy_required = 10,
      ingredients =
      {
        {"electronic-circuit", 1000},
        {"advanced-circuit", 100},
        {type = "fluid", name = "sulfuric-acid", amount = 500}
      },
      result = "processing-unit",
	   result_count = 50
    }
  },
  
   {
    type = "recipe-category",
    name = "circuits"
  },
  
  
  --- EXPRESS LOADERS 
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
})

enable_productivity_recipes = {
"electronic-circuit-factory", "advanced-circuit-factory", "processing-unit-factory"
}

for k, v in pairs(data.raw.module) do
if v.name:find("productivity%-module") and v.limitation then
for _, recipe in ipairs(enable_productivity_recipes) do
if data.raw["recipe"][recipe] then
table.insert(v.limitation, recipe)
end
end
end
end